﻿;-------------------------------------------------------------------------------
; Anagrams.ahk
; by wolf_II
;-------------------------------------------------------------------------------
; search for (real-word) anagrams for a given (arbitrary) string of letters
;-------------------------------------------------------------------------------
;
; written with massive help by Helgef from AHK forum:
; https://autohotkey.com/boards/viewtopic.php?p=158284#p158284
;
; thread about this script and even more help from Helgef:
; https://autohotkey.com/boards/viewtopic.php?p=158464#p158464
;
; Thanks to tic (Tariq Porter) for his GDI+ Library
; http://www.autohotkey.com/forum/viewtopic.php?t=32238
;
; Thanks to HelgeF for his Taskbar Ornaments Library
; <link to forum thread>
;
;-------------------------------------------------------------------------------



;-------------------------------------------------------------------------------
AutoExecute: ; auto-execute section of the script
;-------------------------------------------------------------------------------
    #NoEnv                              ; don't check empty variables
    #SingleInstance, Force              ; kill old instance
    ;---------------------------------------------------------------------------
    OnExit("CleanUp")                   ; #SingleInstance and Reload behaviour
    SetBatchLines, -1                   ; run script at maximum speed
    SetWorkingDir, %A_ScriptDir%        ; consistent directory
    SplitPath, A_ScriptName,,,, AppName ; get AppName from file name
    ;---------------------------------------------------------------------------
    Version := "2.13"
    ;===========================================================================

    Max_Input_Length := 26
    Gosub, Handle_INI

    ; Menus
    Menu, Tray, Icon, %AppName%.icl
    Menu, Tray, Icon ; show
    Menu, ContextMenu, Add, Copy all items to clipboard, CopyAll
    Menu, ContextMenu, Add, Copy selection to clipboard, CopySelection
    Menu, ContextMenu, Add ; separator
    Menu, ContextMenu, Add, Show permutations of selected items, ShowPerms

    ; display GUI while loading
    Gosub, MainGuiCreate
    Gosub, PermGuiCreate
    Gosub, MainGuiShow

    ; load word list
    WordCount := Make_DICT()

    ; loading is done
    SB_SetText("Words: " prettify_Number(WordCount), 3)
    GuiControl, Hide, Loading
    GuiControl, -Center -Disabled +gShowAnagrams, Input
    GuiControl, Choose, WCount, %LastWCount%
    GuiControl, Choose, Skip, %LastSkip%
    GuiControl,, Input, %LastInput%
    GuiControl, Focus, Input
    SendMessage, 0xB1, %LastPos%, %LastPos%,, ahk_id %hEdit% ; EM_SETSEL
    MySpinner := new Spinner([], hLV)

Return ; end of auto-execute section



;-------------------------------------------------------------------------------
#Include, *i %A_ScriptDir%\Include ; set folder for includes
;-------------------------------------------------------------------------------
    #Include, GUI.Create.ahk
    #Include, GUI.Events.ahk
    #Include, GUI.Handler.ahk
    #Include, INI.Handler.ahk
    #Include, MainCode.ahk
    #Include, Make_DICT.ahk
    #Include, setupTaskbar.ahk



;-------------------------------------------------------------------------------
; Library files
;-------------------------------------------------------------------------------
    #Include, <class.Spinner>
    #Include, <prettify_Number>
    #Include, <QPC>
    #Include, <RadioBox>
    #Include, <taskbarInterface>
    #Include, <threadFunc>
    #Include, <ToolTip>
    #Include, <WM_MOVE>



/*--------- end of file --------------------------------------------------------
