﻿


;-------------------------------------------------------------------------------
ShowMenu: ; ListView onEvent
;-------------------------------------------------------------------------------
    If (A_GuiEvent = "RightClick")
        Menu, ContextMenu, Show

Return



;-------------------------------------------------------------------------------
CopyAll: ; copy WordList to clipboard
;-------------------------------------------------------------------------------
    Clipboard := StrReplace(WordList, "|", "`r`n", WordListSize)
    ToolTip(++WordListSize " items copied")

Return



;-------------------------------------------------------------------------------
CopySelection: ; copy selection to clipboard
;-------------------------------------------------------------------------------
    Row := 0, Txt4Copying := ""
    Gui, Main: Default
    Loop, % SelectedCount := LV_GetCount("Selected") {
        Row := LV_GetNext(Row)
        LV_GetText(TxtFromListView, Row)
        Txt4Copying .= TxtFromListView "`r`n"
    }

    Clipboard := RTrim(Txt4Copying, "`r`n")
    ToolTip(SelectedCount " items copied")

Return



;-------------------------------------------------------------------------------
ShowPerms: ; popup a window showing permutations of all selected items
;-------------------------------------------------------------------------------
    Gui, Main: Default

    Row := 0, LBox := "", PCount := 0
    Loop, % LV_GetCount("Selected") {
        Row := LV_GetNext(Row)
        LV_GetText(TxtFromListView, Row)
        LBox .= "|" TxtFromListView
    }

    SentenceList := StrSplit(LTrim(LBox, "|"), "|")
    LBox := ""
    For each, Sentence in SentenceList
        For each, Perm in Permutations(Sentence)
            LBox .= "|" Perm, PCount++

    Gui, Main: +Disabled
    Gui, Perm: Default
    GuiControl, Hide, LBox
    GuiControl,, LBox, %LBox%
    GuiControl, Show, LBox
    SB_SetText("Count: " PCount)
    Gui, Show

Return



;-------------------------------------------------------------------------------
ShowAnagrams: ; live display all anagrams of Input found in Dictionary
;-------------------------------------------------------------------------------
    Gui, Submit, NoHide

	tbi.setOverlayIcon(tbi.hOverlaySearching)
	tbi.setProgressType("INDETERMINATE")	; Set unknown progress
	tbi.disableButton(1)					; Disable buttons while calculating
	tbi.disableButton(2)

    InputLength := StrLen(Input)
    SB_SetText("Length: " InputLength, 1)
    InputZ := StrReplace(Input, A_Space)
    SpaceCount := WCount - 1 ; adjust from # of words to # of spaces

    If (WCount = 1) ; single words
        GuiControl, +Disabled, WCount


    If (InputLength > 12) { ; reduce flashing
        GuiControl, +Disabled, Input
        GuiControl, +Disabled, WCount
        GuiControl, +Disabled, Skip
        GuiControl, +Disabled, LView
        MySpinner.Start()
    }

    If (InputLength > Max_Input_Length) {
        MySpinner.Stop()

		tbi.setProgressType("Off") 		; Restore progress
		tbi.enableButton(1)
		tbi.enableButton(2)
        LV_Delete(), LV_Add(, "Input too long")
        GuiControl, -Disabled, Input
        GuiControl, -Disabled, WCount
        GuiControl, -Disabled, Skip
        GuiControl, -Disabled, LView
        GuiControl, Focus, Input
        Return
    }

    WordList := "", LV_Delete()
    Start := QPC() ; ===========================================================

    If (SpaceCount) { ; find muliple-words anagrams
        For each, Sentence in MultiWordAnagrams(InputZ, SpaceCount) {
            Sort, Sentence, D%A_Space%
            WordList .= WordList ? "|" Sentence : Sentence
        }
        Sort, WordList, D| ; all entries are the same length
    }

    Else { ; find single word anagrams
        For each, Set in Combinations(InputZ, Skip)
            For Keyword, Size in Set
                For each, Anagram in DICT[Size, Keyword]
                    WordList .= WordList ? "|" Anagram : Anagram
        Sort, WordList, D| F LengthSort
    }

    TimeTaken := QPC() - Start ; time in s =====================================

    GuiControl, -Redraw, LView
    If (WordList = "")
        LV_Add(, "no anagrams for " Input)
    Else
        For each, Word in StrSplit(WordList, "|")
            LV_Add(, Word)
    GuiControl, +Redraw, LView

    SB_SetText("Count: " prettify_Number(LV_GetCount()), 2)
    SB_SetText("Time: " Round(TimeTaken, 3) " s", 4)
    MySpinner.Stop()
	tbi.setProgressType("Off")				; restore progress
    tbi.setOverlayIcon(tbi.hOverlayDone)	; Set overlay icon to done
	tbi.enableButton(1)						; Reenable buttons
	tbi.enableButton(2)
    GuiControl, -Disabled, Input
    GuiControl, -Disabled, WCount
    If (WCount = 1) ; single words
        GuiControl, -Disabled, Skip
    GuiControl, -Disabled, LView
    GuiControl, Focus, Input

Return
